﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Silanis.ESL.SDK;
using Silanis.ESL.SDK.Builder;
using System.Diagnostics;
using System.Net.Http;
using System.Net.Http.Headers;
using Newtonsoft.Json.Linq;

namespace SignatureManagement
{
    class SignatureManagement
    {
        private static string key = "api_key";
        private static string url = "https://sandbox.esignlive.com/api";
        
        public static void Main(string[] args)
        {

            EslClient client = new EslClient(key, url);

            PackageId packageId = new PackageId("F0-ZikTc-efqihIkHzOe3KeCSK4=");

            String documentId = "92b260f6df96f94c";

            //Add a signature

            Signature signature = SignatureBuilder.SignatureFor("john.smith@mailinator.com")
                      .OnPage(0)
                      .AtPosition(215, 510)
                      .WithSize(200, 50)
                      .WithId(new SignatureId("signature1"))
                      .Build();

            DocumentPackage createdPackage = client.GetPackage(packageId);
            client.ApprovalService.AddApproval(createdPackage, documentId, signature);

            //Update a signature
            Signature updatedSignature = SignatureBuilder.CaptureFor("john.smith@mailinator.com")
                      .OnPage(0)
                      .AtPosition(215, 510)
                      .WithSize(300, 50)
                      .WithId(new SignatureId("signature1"))
                      .Build();

            IList<Signature> signatures = new List<Signature>();
            signatures.Add(updatedSignature);

            DocumentPackage updatedPackage = client.GetPackage(packageId);
            client.ApprovalService.UpdateApprovals(updatedPackage, documentId, signatures);

            //Delete a signature
            client.ApprovalService.DeleteApproval(packageId, documentId, "signature1");
        }
    }
}
